<?php
ob_start();

// Require the initialisation file
require_once '../../../../init.php';

// Required files
require_once MAX_PATH . '/lib/OA/Admin/Option.php';
require_once MAX_PATH . '/www/admin/config.php';
require_once MAX_PATH . '/lib/max/Plugin/Translation.php';


//security check
OA_Permission::enforceAccount(OA_ACCOUNT_ADMIN);

$title="Add Device";
$oHeaderModel = new OA_Admin_UI_Model_PageHeaderModel($title);
phpAds_PageHeader('custom-categorylist', $oHeaderModel);

if($GLOBALS['_MAX']['CONF']['database']['type']=='pgsql')
{
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
}
else if($GLOBALS['_MAX']['CONF']['database']['type']=='mysqli')
{
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
}

$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
if($_REQUEST['submit']=='submit')
{		
	//Insert Category	
	OA_Dal_delivery_query("INSERT INTO djax_device_target(device_name,parent_device_id,is_blocked) VALUES ('".$_POST['category']."',0,0)");
	$parent_id = OA_Dal_Delivery_insertId();
	
	//Insert subcategory
	$subCat = $_POST['subcat'];
	$i=1;
	foreach($subCat as $subcat){
		OA_Dal_delivery_query("INSERT INTO djax_device_target(device_name,parent_device_id,is_blocked) VALUES ('".$subcat."','".$parent_id."',0)");
		$i++;
	}
	
	$translation = new OX_Translation();
	$translated_message = $translation->translate ("<b> device has been added Successfully.</b>");
	OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);	
	header('Location:custom-category.php');
}
?>

<style>
 td:first-child{
	padding-right: 5px;
	}
 td{
	padding-top: 5px; 
	}
 #deletesub{
	display: none; 
	}
</style>

<script src="assets/js/jquery-1.12.4.js"></script>

<script>
	var jq = jQuery.noConflict();
	jq.browser = {};
	(function () {
		jq.browser.msie = false;
		jq.browser.version = 0;
		if (navigator.userAgent.match(/MSIE ([0-9]+)\./)) {
			jq.browser.msie = true;
			jq.browser.version = RegExp.$1;
		}
	})();
	function addSubcategory(e)
	{
		if(jq('#subcategory tr').length > 0){
			jq('#deletesub').css('display','initial');
		}
		jq('#subcategory').append('<tr><td>Sub category Name:</td>				<td><input type="text" name="subcat[]" required></td></tr>');
	}
	
	function deleteSubcategory(e)
	{		
		if(jq('#subcategory tr').length == 2){
			jq('#deletesub').css('display','none');
		}
		jq('#subcategory tr:last').remove();
	}

</script>

<div id="dj_header">
	<form  action='' method='post' name='settingsform' id='settingsform1' class='form-inline' enctype='multipart/form-data'>
		<div class="control-group">
			<h3>Device Details</h3>
			<hr/>
			<br/><br/>
		<div>
		<table>
			<tr>
				<td> Device Name:</td>
				<td><input type="text" name="category" id="category" required></td>
			</tr>
		</table>
		<br/><br/>
		<br/><br/>
		<!-- <div class="control-group">
			<h3>Sub Device Details</h3>
			<hr/>
			<br/><br/>
		<div> -->
		<!-- <table id="subcategory">
			<tr>
				<td>Sub Device Name:</td>
				<td><input type="text" name="subcat[]" required></td>
				<td>&nbsp;&nbsp;<img src="assets/images/plus.png" width='15' onClick="addSubcategory(this);"></td>
				<td>&nbsp;&nbsp;<img src="assets/images/minus1.jpg" width='15' onClick="deleteSubcategory(this);" id="deletesub"></td>
			</tr>
		</table> -->
		<div style="padding-top: 10px;">
			<table>
				<tr>
					<td>&nbsp;</td>
					<td><input type="submit" name='submit' value="submit"></td>
				</tr>
			</table>
		</div>
	</form>
</div>
<?php
phpAds_PageFooter();
ob_flush();
