<?php

ob_start();
// Require the initialisation file
require_once '../../../../init.php';

// Required files
require_once MAX_PATH . '/www/admin/config.php';
require_once MAX_PATH . '/lib/max/Plugin/Translation.php';


//security check
OA_Permission::enforceAccount(OA_ACCOUNT_ADMIN);

$title="Edit Device";
$oHeaderModel = new OA_Admin_UI_Model_PageHeaderModel($title);
phpAds_PageHeader('custom-categorylist', $oHeaderModel);

 if($GLOBALS['_MAX']['CONF']['database']['type']=='pgsql')
{
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
}
else if($GLOBALS['_MAX']['CONF']['database']['type']=='mysqli')
{
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
}

$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];

$category_id = $_REQUEST['id'];

$getCat = OA_Dal_Delivery_fetchAssoc(OA_Dal_Delivery_query("SELECT * FROM djax_device_target WHERE device_id='{$category_id}'"))or die("Error in get device");

$getSub = OA_Dal_Delivery_query("SELECT * FROM djax_device_target WHERE device_id='{$category_id}' ORDER BY device_id ASC");

if($_POST['submit']=='submit')
{
	$delsub = $_POST['deleteSub'];
	$cat = $_POST['category'];
	$subcat = $_POST['subcat'];
	$catid = $_POST['catid'];
	$catblock = $_POST['is_blocked'];
	
	//update category
	OA_Dal_Delivery_query("UPDATE djax_device_target SET device_name='".$cat."'WHERE device_id='".$catid."'")or die("category update");  
	
	//update sub category
	foreach($subcat as $key => $value){
		if($key == "'newsub'"){
			foreach($value as $value1){
				OA_Dal_delivery_query("INSERT INTO djax_device_target(device_name,parent_device_id,is_blocked) VALUES ('".$value1."','".$catid."','".$catblock."')")or die("subcategory insert");
			}
			
		}else{
			
			OA_Dal_Delivery_query("UPDATE djax_device_target SET device_name='".$value."'WHERE device_id='".$key."'")or die("subcategory update");  
	
		}
	}
	
	//delete subcategory
	$delsub = explode(',',$delsub);
	foreach($delsub as $delSub)
	{		
		OA_Dal_Delivery_query("DELETE FROM djax_device_target WHERE device_id='".$delSub."'") or die("error in delete");
	}
	
	$translation = new OX_Translation();
	$translated_message = $translation->translate ("<b> Categodevicery has been updated Successfully.</b>");
	OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);	
	header('Location: custom-category.php');
	exit;

}
?>

<style>
 td:first-child{
	padding-right: 5px;
	}
 td{
	padding-top: 5px; 
	}
	
 #deletesub{
	display: none; 
	}

</style>

<script src="assets/js/jquery-1.12.4.js"></script>

<script>
	var jq = jQuery.noConflict();
	jq.browser = {};
	(function () {
		jq.browser.msie = false;
		jq.browser.version = 0;
		if (navigator.userAgent.match(/MSIE ([0-9]+)\./)) {
			jq.browser.msie = true;
			jq.browser.version = RegExp.$1;
		}
	})();
	function addSubcategory(e){
		if(jq('#subcategory tr').length > 0){
			jq('#deletesub').css('display','initial');
		}
		jq('#subcategory').append('<tr class=""><td>Sub category Name:</td>		<td><input type="text" name="subcat[\'newsub\'][]" required></td><td>&nbsp;&nbsp;<img src="assets/images/minus1.jpg" width="15" onClick="deleteSubcategory1(this);" id="deletesub1"></td></tr>');
		
	}
	
	function deleteSubcategory1(e)
	{
		if(jq(e).parent().parent().attr('class') != ''){
			var del = jq("#deleteSub").val();
			if(del != ''){
				del = del+','+jq(e).parent().parent().attr('class');
			}else{
				del = jq(e).parent().parent().attr('class');
			}
			jq("#deleteSub").val(del);
		}
		jq(e).parent().parent().remove();		
	}

</script>

<?php

if(OA_Dal_Delivery_numRows($getSub) > 0){


		$i=1;
	
	?>
		<div id="dj_header">
			<form  action='' method='post' name='settingsform' id='settingsform1' class='form-inline' enctype='multipart/form-data'>
				<div class="control-group">
					<h3>Category Details</h3>
					<hr/>
					<br/><br/>
				<div>
				<table>
					<tr>
						<td> Device Name:</td>
						<td><input type="text" name="category" id="category" value="<?php echo $getCat['device_name'];?>" required></td>
					</tr>
				</table>
				<br/><br/>
				<br/><br/>

				<!-- <div class="control-group">
					<h3>Sub Device Details</h3>
					<hr/>
					<br/><br/>
				<div> -->
				<!-- <table id="subcategory">
					<?php while($getsub = OA_Dal_Delivery_fetchAssoc($getSub)){ ?>
					<tr class="<?php echo $getsub['device_id'];?>">
						<td>Sub Device Name:</td>
						
						<?php if($i==1){ ?>
						<td><input type="text" name="subcat[<?php echo $getsub['device_id'];?>]" value=<?php echo $getsub['device_name'];?> required></td>
						<td>&nbsp;&nbsp;<img src="assets/images/plus.png" width='15' onClick="addSubcategory(this);"></td>
						<?php }else{ ?>
						<td><input type="text" name="subcat[<?php echo $getsub['device_id'];?>]" value=<?php echo $getsub['device_name'];?>></td>
						<td>&nbsp;&nbsp;<img src="assets/images/minus1.jpg" width='15' onClick="deleteSubcategory1(this);" id="deletesub1"></td>
						<?php }?>
					</tr>
					<?php $i++;
					
						}?>
				</table> -->
				<div>
					<input type="hidden" name="deleteSub" id="deleteSub">
					<input type="hidden" name="catid" value="<?php echo $getCat['device_id'];?>">
					<input type="hidden" name="is_blocked" value="<?php echo $getCat['is_blocked'];?>">
				</div>
				<div style="padding-top: 10px;">
					<table>
						<tr>
							<td>&nbsp;</td>
							<td><input type="submit" name='submit' value="submit"></td>
						</tr>
					</table>
				</div>
			</form>
		</div>
	
	<?php
}else{
	
 echo "<div style='text-align:center;font-size: 18px;'><b>No data found</b></div>";	

}
phpAds_PageFooter();
ob_flush();

